
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

#include "ext.h"
#include "ext_obex.h"
#include "jpatcher_api.h"

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
#pragma mark -
    
typedef struct _flop {
    t_object    ob;
    void        *outlet;
    } t_flop;

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
#pragma mark -

void *flop_new  (t_symbol *s, long argc, t_atom *argv);
void flop_free  (t_flop *x);
void flop_bang  (t_flop *x);

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
#pragma mark -
        
static t_class *flop_class;

int main(void)
{   
    t_class *c = NULL;
    
    c = class_new("flop", (method)flop_new, (method)flop_free, (long)(sizeof(t_flop)), 0L, A_GIMME, 0);
    class_addmethod(c, (method)flop_bang, "bang", 0);
    class_register(CLASS_BOX, c);
    flop_class = c;
        
    return 0;
}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
#pragma mark -

void *flop_new(t_symbol *s, long argc, t_atom *argv)
{
    t_flop *x = NULL;
    
    if ((x = (t_flop *)object_alloc(flop_class))) {
        x->outlet = bangout((t_object *)x);
    }   
        
    return x;
}

void flop_free(t_flop *x)
{ 
    ;
}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
#pragma mark -

void flop_bang(t_flop *x) 
{  
    t_object *p = NULL; 
    t_object *v = NULL;     
    
    if ((p = (t_object *)stringload("HabemusPapam.maxpat")) && (v = jpatcher_get_firstview(p))) {
        patcherview_set_visible(v, 0);
    }
}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
